﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication84;
using System.Reflection;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Models;
using Syncfusion.JavaScript.Shared.Serializer;
namespace SyncfusionMvcApplication84.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public int flag = 1;
        public static List<Orders> order = new List<Orders>();
        OrdersTable obj = new OrdersTable();
        public ActionResult GridFeatures()
        {
          var datasource =  Data();
          ViewBag.datasource = datasource;
          return View(datasource);
        }
        public object Data()
        {
            Orders studentTestScore = order.First();
            Type modelType = studentTestScore.GetType();
            IList<PropertyInfo> props = new List<PropertyInfo>(modelType.GetProperties());

            IList<object> dataSource = new List<object>();
            IList<string> headers = new List<string>();

            foreach (Orders sts in order)
            {
                Dictionary<string, string> dic = new Dictionary<string, string>();
                foreach (PropertyInfo prop in props)
                {
                    string propName = prop.Name;
                    var val = prop.GetValue(sts, null);
                    if (val != null && propName != "StudNo" && propName != "SchoolYear" && propName != "Data")
                    {
                        string header = propName;
                        string myType = val.GetType().Name.ToString();
                        if (myType.ToLower().Contains("list")) // this is ScoreInfo
                        {
                            var scoreInfoLst = (List<ScoreInfo>)val;
                            if (scoreInfoLst.Count > 0)
                            {
                                ScoreInfo scoreInfo = scoreInfoLst[0];
                                header = String.Format("{0}{1}{2}", scoreInfo.Score, scoreInfo.AdministrationName, propName);
                                dic.Add(header, scoreInfo.Score.ToString());
                                if (!headers.Contains(header))
                                {
                                    headers.Add(header);
                                }

                            }
                        }
                        else
                        {
                            if (header == "OrderID") header = "OrderID"; //col.Field("FirstName").HeaderText("First Name").TextAlign(TextAlign.Left).Add();
                            if (header == "EmployeeID") header = "EmployeeID"; //col.Field("LastName").HeaderText("Last Name").TextAlign(TextAlign.Left).Add();
                            dic.Add(header, val.ToString());
                            if (!headers.Contains(header))
                            {
                                headers.Add(header);
                            }

                        }
                    }
                }

                dataSource.Add((object)dic);
            }

            List<Column> cols = new List<Column>();
            foreach (string h in headers)
            {
                cols.Add(new Column() { Field = h, HeaderText = h });
            }
            ViewBag.columns = cols;
            return (IEnumerable<object>)dataSource;
        }
        public ActionResult NewColumn()
        {
            Orders studentTestScore = order.First();
            Type modelType = studentTestScore.GetType();
            IList<PropertyInfo> props = new List<PropertyInfo>(modelType.GetProperties());

            IList<object> dataSource = new List<object>();
            IList<string> headers = new List<string>();

            foreach (Orders sts in order)
            {
                Dictionary<string, string> dic = new Dictionary<string, string>();
                foreach (PropertyInfo prop in props)
                {
                    string propName = prop.Name;
                    var val = prop.GetValue(sts, null);
                    if (val != null && propName != "StudNo" && propName != "SchoolYear" && propName != "Data")
                    {
                        string header = propName;
                        string myType = val.GetType().Name.ToString();
                        if (myType.ToLower().Contains("list")) // this is ScoreInfo
                        {
                            var scoreInfoLst = (List<ScoreInfo>)val;
                            if (scoreInfoLst.Count > 0)
                            {
                                ScoreInfo scoreInfo = scoreInfoLst[0];
                                header = String.Format("{0}{1}{2}", scoreInfo.Score, scoreInfo.AdministrationName, propName);
                                dic.Add(header, scoreInfo.Score.ToString());
                                if (!headers.Contains(header))
                                {
                                    headers.Add(header);
                                }

                            }
                        }
                        else
                        {
                            if (header == "OrderID") header = "OrderID"; //col.Field("FirstName").HeaderText("First Name").TextAlign(TextAlign.Left).Add();
                            if (header == "EmployeeID") header = "EmployeeID"; //col.Field("LastName").HeaderText("Last Name").TextAlign(TextAlign.Left).Add();
                            dic.Add(header, val.ToString());
                            if (!headers.Contains(header))
                            {
                                headers.Add(header);
                            }

                        }
                    }
                }

                dataSource.Add((object)dic);
            }

            List<Column> cols = new List<Column>();
            foreach (string h in headers)
            {
                cols.Add(new Column() { Field = h, HeaderText = h });
            }
            SerializeObject serialize = new SerializeObject();
              string newcol = serialize.SerializeToJson(cols.Take(4).ToList());// serialize the new coluumns columns
             return Json(newcol);
        }
        public class ColumnDetails
        {
            public ColumnDetails()
            {

            }
            public ColumnDetails(String Field, string HeaderText)
            {
                this.Field = Field;
                this.HeaderText = HeaderText;
            }
            public string Field { get; set; }
            public string HeaderText { set; get; }
        }
        public class Orders
        {
            public Orders() { }
            public Orders(int orderId, string customerId, int empId, Decimal freight, DateTime orderDate, string shipCity, bool verified,
                string ShipName, string ShipCountry, string ShipPostalCode, string ShipAddress, string ShipRegion,List<ScoreInfo> Score ,List<ScoreInfo> Name)
            {
                this.OrderID = orderId;
                this.CustomerID = customerId;
                this.EmployeeID = empId;
                this.Freight = freight;
                this.OrderDate = orderDate;
                this.ShipCity = shipCity;
                this.Verified = verified;
                this.ShipAddress = ShipAddress;
                this.ShipName = ShipName;
                this.ShipCountry = ShipCountry;
                this.ShipPostalCode = ShipPostalCode;
                this.ShipRegion = ShipRegion;
                this.Score = Score;
                this.Name = Name;
            }
            public int OrderID { get; set; }
            public string ShipName { get; set; }
            public string ShipCountry { get; set; }
            public string ShipPostalCode { get; set; }
            public string ShipAddress { get; set; }
            public string ShipRegion { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public Decimal Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
            public bool Verified { get; set; }
            public List<ScoreInfo> Score { get; set; }
            public List<ScoreInfo> Name { get; set; }
        }
        public class OrdersTable
        {
            public OrdersTable()
            {
                //adrs1.Address1 = 
                int orderId = 10000;
                int empId = 0;
                for (int i = 1; i < 9; i++)
                {
                    order.Add(new Orders(orderId + 1, "VINET", empId + 1, 11.00093m, new DateTime(2014, 12, 25, 11, 30, 20), "Reims", true, "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", new List<ScoreInfo> { new ScoreInfo(100,"2000","xxx") }, new List<ScoreInfo> { new ScoreInfo(100,"2000","xxx") }));
                    order.Add(new Orders(orderId + 2, "TOMSP", empId + 2, 11.89879m, new DateTime(2014, 12, 21, 10, 24, 40), "Munster", false, "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", new List<ScoreInfo> { new ScoreInfo(101, "2001", "yyy") }, new List<ScoreInfo> { new ScoreInfo(101, "2001", "yyy") }));
                    order.Add(new Orders(orderId + 3, "ANATER", empId + 3, 45.284357934m, new DateTime(2014, 10, 18, 20, 40, 34), "Berlin", true, "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", new List<ScoreInfo> { new ScoreInfo(102, "2002", "zzz") }, new List<ScoreInfo> { new ScoreInfo(101, "2001", "yyy") }));
                    order.Add(new Orders(orderId + 4, "ALFKI", empId + 4, 37.487923m, new DateTime(2014, 11, 23, 23, 4, 23), "Mexico", true, "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", new List<ScoreInfo> { new ScoreInfo(103, "2003", "xxx") }, new List<ScoreInfo> { new ScoreInfo(101, "2001", "yyy") }));
                    order.Add(new Orders(orderId + 5, "FRGYE", empId + 5, 67.1289734m, new DateTime(2014, 05, 05, 10, 8, 50), "Colchester", true, "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", new List<ScoreInfo> { new ScoreInfo(104, "2004", "yyy") }, new List<ScoreInfo> { new ScoreInfo(101, "2001", "yyy") }));
                    order.Add(new Orders(orderId + 6, "JGERT", empId + 6, 23.239487293m, new DateTime(2014, 10, 18, 06, 55, 59), "Newyork", true, "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", "Victuailles en stock", new List<ScoreInfo> { new ScoreInfo(105, "2005", "xxx") }, new List<ScoreInfo> { new ScoreInfo(101, "2001", "yyy") }));
                    orderId += 6;
                    empId += 6;
                }
            }
        }
        public class ScoreInfo
        {
            public ScoreInfo() { }
            public ScoreInfo(int Score, string SchoolYear, string AdministrationName)
            {
                this.Score = Score;
                this.Schoolyear = Schoolyear;
                this.AdministrationName = AdministrationName;
        }
            public int Score { get; set; }
            public string Schoolyear { get; set; }
            public string AdministrationName { get; set; }
        }
    }
}
